Panda3D

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
BillboardEffect Class Reference

Indicates that geometry at this node should automatically rotate to face the camera, or any other arbitrary node. More...

`#include "billboardEffect.h"`

Inheritance diagram for BillboardEffect:

## Public Member Functions
virtual void | adjust_transform (CPT(TransformState) &net_transform, CPT(TransformState) &node_transform, const PandaNode *node) const
virtual int | complete_pointers (TypedWritable **plist, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin(). More...
virtual | CPT (TransformState) prepare_flatten_transform(const TransformState *net_transform) const
virtual void | cull_callback (CullTraverser *trav, CullTraverserData &data, CPT(TransformState) &node_transform, CPT(RenderState) &node_state) const
virtual TypeHandle | force_init_type ()
bool | get_axial_rotate () const
| Returns true if this billboard rotates only around the axis of the up vector, or false if it rotates freely in three dimensions. More...
bool | get_eye_relative () const
| Returns true if this billboard interprets the up vector relative to the camera, or false if it is relative to the world. More...
bool | get_fixed_depth () const
| Returns true if this billboard always appears at a fixed distance from the camera. More...
const NodePath & | get_look_at () const
| Returns the node this billboard will rotate to look towards. More...
const LPoint3 & | get_look_at_point () const
| Returns the point, relative to the look_at node, towards which the billboard will rotate. More...
PN_stdfloat | get_offset () const
| Returns the distance toward the camera (or the look_at_point) the billboard is moved towards, after rotating. More...
virtual TypeHandle | get_type () const
const LVector3 & | get_up_vector () const
| Returns the up vector in effect for this billboard. More...
virtual bool | has_adjust_transform () const
virtual bool | has_cull_callback () const
bool | is_off () const
| Returns true if the BillboardEffect is an 'off' BillboardEffect, indicating that it does not enable billboarding. More...
virtual void | output (std::ostream &out) const
virtual bool | safe_to_transform () const
| Returns true if it is generally safe to transform this particular kind of RenderEffect by calling the xform() method, false otherwise. More...
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file. More...
Public Member Functions inherited from RenderEffect
| RenderEffect (const RenderEffect &copy)=delete
virtual | ~RenderEffect ()
| The destructor is responsible for removing the RenderEffect from the global set if it is there. More...
int | compare_to (const RenderEffect &other) const
| Provides an arbitrary ordering among all unique RenderEffects, so we can store the essentially different ones in a big set and throw away the rest. More...
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed. More...
RenderEffect & | operator= (const RenderEffect &copy)=delete
virtual bool | safe_to_combine () const
virtual void | write (std::ostream &out, int indent_level) const
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type. More...
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object. More...
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string. More...
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter. More...
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams. More...
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed. More...
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static | CPT (RenderEffect) make(const LVector3 &up_vector
static | CPT (RenderEffect) make_axis()
static | CPT (RenderEffect) make_point_eye()
static | CPT (RenderEffect) make_point_world()
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
Static Public Member Functions inherited from RenderEffect
static TypedWritable * | change_this (TypedWritable *old_ptr, BamReader *manager)
| Called immediately after complete_pointers(), this gives the object a chance to adjust its own pointer if desired. More...
static TypeHandle | get_class_type ()
static int | get_num_effects ()
static void | init_type ()
static void | list_effects (std::ostream &out)
| Lists all of the RenderEffects in the cache to the output stream, one per line. More...
static bool | validate_effects ()
| Ensures that the cache is still stored in sorted order. More...
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes. More...
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
static bool bool | axial_rotate
static bool | eye_relative
static bool bool PN_stdfloat const NodePath const LPoint3 bool | fixed_depth = false)
static bool bool PN_stdfloat const NodePath & | look_at
static bool bool PN_stdfloat const NodePath const LPoint3 & | look_at_point
static bool bool PN_stdfloat | offset
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

Indicates that geometry at this node should automatically rotate to face the camera, or any other arbitrary node.

Definition at line 27 of file billboardEffect.h.

## Member Function Documentation

## ◆ complete_pointers()

int BillboardEffect::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager
| ) |  |
| virtual

Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().

Returns the number of pointers processed.

Reimplemented from TypedWritable.

Definition at line 332 of file billboardEffect.cxx.

## ◆ get_axial_rotate()

bool BillboardEffect::get_axial_rotate | ( |  | ) | const
| inline

Returns true if this billboard rotates only around the axis of the up vector, or false if it rotates freely in three dimensions.

Definition at line 84 of file billboardEffect.I.

## ◆ get_eye_relative()

bool BillboardEffect::get_eye_relative | ( |  | ) | const
| inline

Returns true if this billboard interprets the up vector relative to the camera, or false if it is relative to the world.

Definition at line 75 of file billboardEffect.I.

## ◆ get_fixed_depth()

bool BillboardEffect::get_fixed_depth | ( |  | ) | const
| inline

Returns true if this billboard always appears at a fixed distance from the camera.

Definition at line 93 of file billboardEffect.I.

## ◆ get_look_at()

const NodePath & BillboardEffect::get_look_at | ( |  | ) | const
| inline

Returns the node this billboard will rotate to look towards.

If this is empty, it means the billboard will rotate towards the current camera node, wherever that might be.

Definition at line 113 of file billboardEffect.I.

## ◆ get_look_at_point()

const LPoint3 & BillboardEffect::get_look_at_point | ( |  | ) | const
| inline

Returns the point, relative to the look_at node, towards which the billboard will rotate.

Normally this is (0, 0, 0).

Definition at line 122 of file billboardEffect.I.

## ◆ get_offset()

PN_stdfloat BillboardEffect::get_offset | ( |  | ) | const
| inline

Returns the distance toward the camera (or the look_at_point) the billboard is moved towards, after rotating.

This can be used to ensure the billboard is not obscured by nearby geometry.

Definition at line 103 of file billboardEffect.I.

## ◆ get_up_vector()

const LVector3 & BillboardEffect::get_up_vector | ( |  | ) | const
| inline

Returns the up vector in effect for this billboard.

Definition at line 66 of file billboardEffect.I.

## ◆ is_off()

bool BillboardEffect::is_off | ( |  | ) | const
| inline

Returns true if the BillboardEffect is an 'off' BillboardEffect, indicating that it does not enable billboarding.

This kind of BillboardEffect isn't particularly useful and isn't normally created or stored in the graph; it might be implicitly discovered as the result of a NodePath::get_rel_state().

Definition at line 58 of file billboardEffect.I.

## ◆ safe_to_transform()

bool BillboardEffect::safe_to_transform | ( |  | ) | const
| virtual

Returns true if it is generally safe to transform this particular kind of RenderEffect by calling the xform() method, false otherwise.

Reimplemented from RenderEffect.

Definition at line 49 of file billboardEffect.cxx.

## ◆ write_datagram()

void BillboardEffect::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg
| ) |  |
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from RenderEffect.

Definition at line 311 of file billboardEffect.cxx.

References Datagram::add_bool(), Datagram::add_stdfloat(), BamWriter::get_file_minor_ver(), RenderEffect::write_datagram(), and NodePath::write_datagram().

The documentation for this class was generated from the following files:

- panda/src/pgraph/billboardEffect.h
- panda/src/pgraph/billboardEffect.cxx
- panda/src/pgraph/billboardEffect.I